//------------------------------------------------------------------
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 PaleVioletRed
#property indicator_width1 2
#property indicator_width2 2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern double SlowSample     = 41;
extern double FastSample     = 25;
extern double Suppression_dB =  0;
extern bool   AutoGainOn     = true;

//
//
//
//
//

double buffUp[];
double buffDn[];
double state[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,buffUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,state);
   if (SlowSample<FastSample)
         {
            int temp = FastSample;
                FastSample = SlowSample;
                SlowSample = temp;
         }
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double kalmans = iCustom(NULL,0,"KalmanAGJW - new",SlowSample,0,0,Suppression_dB,AutoGainOn,0,i);
      double kalmanf = iCustom(NULL,0,"KalmanAGJW - new",FastSample,0,0,Suppression_dB,AutoGainOn,0,i);
         state[i]  = state[i+1];
         buffUp[i] = EMPTY_VALUE;
         buffDn[i] = EMPTY_VALUE;
            if (kalmanf>kalmans) state[i] =  1;
            if (kalmanf<kalmans) state[i] = -1;
            if (state[i] ==  1) buffUp[i] = 1;
            if (state[i] == -1) buffDn[i] = 1;
     }
   return(0);
}

